![GitHub release (latest SemVer)](https://img.shields.io/github/v/release/carissalow/rapids?style=plastic)
[![Snakemake](https://img.shields.io/badge/snakemake-≥5.7.1-brightgreen.svg?style=flat)](https://snakemake.readthedocs.io)
[![Documentation Status](https://github.com/carissalow/rapids/workflows/docs/badge.svg)](https://www.rapids.science/)
![tests](https://github.com/carissalow/rapids/workflows/tests/badge.svg)
[![Contributor Covenant](https://img.shields.io/badge/Contributor%20Covenant-v2.0%20adopted-ff69b4.svg)](code_of_conduct.md) 

# RAPIDS

**R**eproducible **A**nalysis **Pi**peline for **D**ata **S**treams

For more information refer to our [documentation](http://www.rapids.science)

By [MoSHI](https://www.moshi.pitt.edu/), [University of Pittsburgh](https://www.pitt.edu/)

## Installation 

For RAPIDS installation refer to to the [documentation](https://www.rapids.science/1.8/setup/installation/)

## For the installation of the Docker version

1. Follow the [instructions](https://www.rapids.science/1.8/setup/installation/) to setup RAPIDS via Docker (from scratch).

2. Delete current contents in /rapids/ folder when in a container session.
    ```
    cd ..
    rm -rf rapids/{*,.*}
    cd rapids
    ```

3. Clone RAPIDS workspace from Git and checkout a specific branch.
    ```
    git clone "https://repo.ijs.si/junoslukan/rapids.git" .
    git checkout <branch_name>
    ```

4. Install missing “libpq-dev” dependency with bash.
    ```
    apt-get update -y
    apt-get install -y libpq-dev
    ```

5. Restore R venv.
Type R to go to the interactive R session and then:
    ```
    renv::restore()
    ```

6. Install cr-features module 
From: https://repo.ijs.si/matjazbostic/calculatingfeatures.git -> branch modifications_for_rapids. 
Then follow the "cr-features module" section below.  

7. Install all required packages from environment.yml, prune also deletes conda packages not present in environment file.
    ```
    conda env update --file environment.yml –prune
    ```

8. If you wish to update your R or Python venvs.
    ```
    R in interactive session:
    renv::snapshot()
    Python: 
    conda env export --no-builds | sed 's/^.*libgfortran.*$/  - libgfortran/' | sed 's/^.*mkl=.*$/  - mkl/' >  environment.yml
    ```

## cr-features module 

This RAPIDS extension uses cr-features library accessible [here](https://repo.ijs.si/matjazbostic/calculatingfeatures).

To use cr-features library:

- Follow the installation instructions in the [README.md](https://repo.ijs.si/matjazbostic/calculatingfeatures/-/blob/master/README.md).

- Copy built calculatingfeatures folder into the RAPIDS workspace.

- Install the cr-features package by:
    ```
    pip install path/to/the/calculatingfeatures/folder
    e.g. pip install ./calculatingfeatures if the folder is copied to main parent directory
    cr-features package has to be built and installed everytime to get the newest version. 
    Or an the newest version of the docker image must be used.   
    ```